README for the GNUish MS-DOS project.
Copyright (C) 1990 Free Software Foundation, Inc.
Last updated: 90-12-11


The Free Software Foundation (FSF) is not directly interested in
integrating or maintaining ports of GNU software to MS-DOS, because of
limited resources.  These activities take time away from finishing a
complete standalone GNU, which FSF and many in the GNU Project
considers much more important.

However, Thorsten Ohl <td12@ddagsi3.bitnet> is organizing distribution
of such ports and moderating the GNUish MS-DOS project.

The GNUish MS-DOS subdirectory contains both MS-DOS ports of GNU
software and MS-DOS replacements for non-ported GNU software, the
collective whole being dubbed the "GNUish MS-DOS" project.

When several ports of the same tool exist, one of them has been
selected by the moderator of this project.  This does not means that
the selected port is the best possible, it means however that the port
is quite good.  Nobody should feel offended by any selection.

Some tools are possibly dangerous if you do not thoroughly understand
their usage (v.g. `rm -r *').  You ought to know what you are doing.
YOU USE THESE TOOLS AT YOUR OWN RISK.  You *were* warned!


LEGAL CONDITIONS

These programs are free software; you can redistribute them and/or
modify them under the terms of the GNU General Public License as
published by the Free Software Foundation; either version 1, or (at your
option) any later version.

These programs are distributed in the hope that they will be useful, BUT
WITHOUT ANY WARRANTY WHATSOEVER, without even the implied warranties of
merchantability or fitness for a particular purpose.  See the GNU
General Public License (the file COPYING) for more details.


PROJECT MAILING LIST

There is a mailing list to discuss these MS-DOS ports of GNU software.
It is called info-gnu-msdos@wugate.wustl.edu.  It is managed by an
experimental Unix-based listserv program.  Send the command:

    add info-gnu-msdos
to: 
    listserv@wugate.wustl.edu 

to become subscribed to the list.  Send a message containing only
'help' to get more information about the listserv.  Do not send these
commands to info-gnu-msdos.  They should go to the listserv address.

The list is not moderated, not digestified, and open to subscription
by anyone.  Problems with the mailing list should be directed to:

    david@wubios.wustl.edu <David J. Camp>


FTP ARCHIVE SITES

There is currently no room on prep.ai.mit.edu to put these files up
for ftp.  If prep get more disk space, they might become available.
The collection of programs known as the GNUish MS-DOS project is still
available for ftp at the following addresses.  Administrative contacts
and upload directories are listed for the moderator's convenience.

   vulcan.phyast.pitt.edu [130.49.33.16], in pub/pc/gnudos.

	adm contact: Roberto Gomez <roberto@bondi.phyast.pitt.edu>
	upload in: incoming

   ocf.berkeley.edu [128.32.184.254], in pub/GNU/gnuish-msdos.
   sandstrom.berkeley.edu [128.32.234.18], alternatively.

	adm contact: Eric Ng <erc@irss.njit.edu> or <...!ucbvax!argon!erc>
	upload in: pub/GNU/uploads

   wsmr-simtel20.army.mil [26.2.0.74], in pd2:<msdos2.gnuish>.

	adm contact: Keith Petersen <w8sdz@wsmr-simtel20.army.mil>
	uploaded by: David Camp <david@wubios.wustl.edu>

   wuarchive.wustl.edu [128.252.135.4], in mirrors/msdos/gnuish.

	adm contact: David Camp <david@wubios.wustl.edu>

   funic.funet.fi [128.214.6.100], in pub/msdos/gnudos.

	adm contact: Petri Hartoma <msdos1@nic.funet.fi>
	upload in: pub/msdos/incoming


SOURCE CODE

Due to space considerations, only the patches relative to the official
GNU source code (with the source code found on prep.ai.mit.edu being
considered "official") and custom-written source code are provided.
In order to re-compile the GNUish MS-DOS project on your computer, you
need to first obtain the official GNU source code.  GNU documentation
(if any) can also be found within the official GNU source code.

The Free Software Foundation has set up an anonymous FTP site for GNU
software on prep.ai.mit.edu [18.71.0.38].  The distributions present
on that machine are considered "official" and are the best ones to use
with the GNUish MS-DOS project.


EXECUTABLE CODE

For convenience, ready-to-execute binaries are also provided for those
who do not have the necessary compilers, or do not feel like using
them.  User documentation is usually not provided, at least for now,
beyond the documentation provided in the official GNU distribution.


GNUISH MS-DOS CONTENTS

	File		Notes	Description or official sources
	
	cpio11.zoo		prep.ai.mit.edu: pub/gnu/cpio-1.1.tar.Z
	diff114.zoo		prep.ai.mit.edu: pub/gnu/diff-1.14.tar.Z
	fgrep11.zoo		prep.ai.mit.edu: pub/gnu/fgrep-1.1.tar.Z
	find12.zoo	1	prep.ai.mit.edu: pub/gnu/find-1.2.tar.Z
	flex236.zoo		prep.ai.mit.edu: pub/gnu/flex-2.3.6.tar.Z
	futil14.zoo		prep.ai.mit.edu: pub/gnu/fileutils-1.4.tar.Z
	gdbm14.zoo	3	prep.ai.mit.edu: pub/gnu/gdbm-1.4.tar.Z
	gnulib0.zoo	3,4	Port of usual GNU routines
	gptx01.zoo	4	Ask <pinard@iro.umontreal.ca>
	grep15.zoo		prep.ai.mit.edu: pub/gnu/grep-1.5.tar.Z
	inden11.zoo		prep.ai.mit.edu: pub/gnu/indent-1.1.tar.Z
	m4v05.zoo		prep.ai.mit.edu: pub/gnu/m4.tar.Z
	make358.zoo	2	prep.ai.mit.edu: pub/gnu/make-3.58.tar.Z
	mkinf10.zoo	4,5	prep.ai.mit.edu: pub/gnu/elisp.tar.Z
	sed106.zoo		prep.ai.mit.edu: pub/gnu/sed-1.06.tar.Z
	sort03.zoo	4	Future GNU sort, version 0.3
	swalib0.zoo	2,3	Swapping library from <td12@ddagsi3.bitnet>
	
	  1	use `zoo x//' to restore sub-directories
	  2	requires Microsoft C compiler at level 6.0
	  3	this is a source library, not a user program
	  4	GNUish, but unofficial or unreleased GNU product
	  5	includes both makeinfo *and* a stand-alone Info reader

For those interested, the filename for each of packages is selected
according to the following pattern:

	<radix><version><release>.zoo

In this syntax, <radix> is a string of three to six characters to
identify the product, v.g. `futil' indicates GNU file utilities.
<version> is a series of one to three digits indicating the version,
v.g. `14' for `1.4', 358 for `3.58' or `0' for non-released yet; the
decimal point is not necessarily implied after the first digit.  In no
case <radix> and <version> altogether could go over seven characters.
The <release> is nothing for the first edition in GNUish MS-DOS
archives, but might be a single letter for subsequent editions, like
`a', `b', `c', etc. in turn.


FUTURE FILES

The following GNU tools have already been ported to DOS, and will be
added later in the GNUish MS-DOS subdirectory:

	bison chess compress [ce]tags gawk perl rcs readline

The following replacement tools could be made available in the GNUish
MS-DOS subdirectory, in the future:

	freemacs or jove	no editor war, please :-)
	ms_sh162		waiting for bash :-)
	uxutl162		only some of them

Work is being done for:

	tar


README AUTHORS

This README file has been written disjointly by:

	Thorsten Ohl <td12@ddagsi3.bitnet>
	Francois Pinard <pinard@iro.umontreal.ca>
	Eric Ng <erc@irss.njit.edu>
	Richard Stallman <rms@ai.mit.edu>
	David J. Camp <david@wubios.wustl.edu>
----------------------------------------------------------------------<

-- 
Franc,ois Pinard          ``Vivement GNU!''         pinard@iro.umontreal.ca
(514) 588-4656    cp 886 L'Epiphanie (Qc) J0K 1J0    ...!uunet!iros1!pinard
