////////////////////////////////////////////////////////////////////////////////
//    Keyboard input rutines.
//
// The idea of storying keystrokes in an array belongs to Victor Putz.
////////////////////////////////////////////////////////////////////////////////

#define MKEY_UNIT

#include <dos.h>
#include <mstd.h>
#include <mobject.h>
#include <mrect.h>
#include <mfileop.h>
#include <mmem.h>
#include <marray.h>
#include <stdlib.h>
#include <mkey.h>

MKey keyb;

/********************************************/
      MKey :: MKey (void)
/********************************************/
{
    Resize (N_KEYS);
    RepeatDelay = DEFAULT_KEY_REP_DELAY;
    Clear();
}

/********************************************/
 WORD MKey :: Update (void)
/********************************************/
{
WORD key = 0;
    Clear();
    while (kbhit())
    {
       key = getch();
       if (key == 0)
	  key = 0x100 + getch();
       Activate (key);
    }
    return (key);
}

/*******************************************/
      MKey :: ~MKey (void)
/********************************************/
{
}

/*******************************************/
 WORD MKey :: GetKey (void)
/*******************************************/
{
WORD n = 0;
    while (!bArray::operator[](n) && n < N_KEYS)
       ++ n;
    if (n == N_KEYS) n = 0;
    return (n);
}

/*******************************************/
 void MKey :: KeyFlush (void)
/*******************************************/
{
    while (kbhit()) 
       getch();
    Clear();
}

/*******************************************/
 void MKey :: WaitCr (void)
/*******************************************/
{
    while (! bArray :: operator[] (Enter));  // Wait until ENTER key is pressed.
}

