////////////////////////////////////////////////////////////////////////////////
// FILE: MOBJECT
//	The base class for the MLIB hierarchy.
////////////////////////////////////////////////////////////////////////////////

#include <conio.h>
#include <mstd.h>
#include <mobject.h>
#include <mmemutil.h>

/********************************************/
       MObject :: MObject (void)
/********************************************/
{
}

#ifdef USER_NEW_AND_DELETE
/********************************************/
 void * MObject :: operator new
/********************************************/
(SIZE s)
{
void *allocated = NULL;
    allocated = AllocMem (s);
    return (allocated);
}

/********************************************/
 void MObject :: operator delete
/********************************************/
(void *p)
{
    FreeMem (p);
}
#endif

/********************************************/
 classType MObject :: isA (void)
/********************************************/
{
    return (MOBJECT_ID);
}

#ifdef __OBJECT_H
/********************************************/
 LPSTR MObject :: nameOf (void)
/********************************************/
{
    return ("MObject");
}

/********************************************/
 hashValueType MObject :: hashValue (void)
/********************************************/
{
    return (0);
}

/********************************************/
 int  MObject :: isEqual
/********************************************/
(const Object& o)
{
    return (this == (MObject*)&o);
}

#else
/********************************************/
 ostream&         operator<<
/********************************************/
(ostream& os, MObject& o)
{
    o.printOn (os);
    return (os);
}
#endif

/********************************************/
 void MObject :: printOn
/********************************************/
(ostream& os)
{
    os << "MObject";
}
